#!/bin/sh
#
# Shrinks ROOTDIR to TEMPDIR, then builds a disk image IMAGENAME
#

ROOTDIR=rootdir
TEMPDIR=rootdir.shrink
IMAGENAME=pxeimager.img
MOUNTDIR=/mnt

set -e

rm -rf ${TEMPDIR}
cp -ar ${ROOTDIR} ${TEMPDIR}
chroot ${TEMPDIR} dpkg --force-all --purge login libpam-modules libpam-runtime libpam0g libcap1 libdb3
chroot ${TEMPDIR} dpkg --force-all --purge debconf debconf-english gcc-3.3-base libstdc++5 libgcc1 dselect dpkg perl-base diff

# Include only the required Python modules (compiled)
mkdir -p ${TEMPDIR}/tmp/python/lib-dynload
mv ${TEMPDIR}/usr/lib/python2.3/platform.pyc ${TEMPDIR}/tmp/python
mv ${TEMPDIR}/usr/lib/python2.3/posixpath.pyc ${TEMPDIR}/tmp/python
mv ${TEMPDIR}/usr/lib/python2.3/stat.pyc ${TEMPDIR}/tmp/python
mv ${TEMPDIR}/usr/lib/python2.3/UserDict.pyc ${TEMPDIR}/tmp/python
mv ${TEMPDIR}/usr/lib/python2.3/copy_reg.pyc ${TEMPDIR}/tmp/python
mv ${TEMPDIR}/usr/lib/python2.3/types.pyc ${TEMPDIR}/tmp/python
mv ${TEMPDIR}/usr/lib/python2.3/traceback.pyc ${TEMPDIR}/tmp/python
mv ${TEMPDIR}/usr/lib/python2.3/linecache.pyc ${TEMPDIR}/tmp/python
mv ${TEMPDIR}/usr/lib/python2.3/site.pyc ${TEMPDIR}/tmp/python
mv ${TEMPDIR}/usr/lib/python2.3/os.pyc ${TEMPDIR}/tmp/python
rm -r ${TEMPDIR}/usr/lib/python2.3/*
mv ${TEMPDIR}/tmp/python/* ${TEMPDIR}/usr/lib/python2.3
rm -r ${TEMPDIR}/tmp/python

rm -r ${TEMPDIR}/usr/share/locale
rm -r ${TEMPDIR}/usr/share/doc
rm -r ${TEMPDIR}/usr/share/man
rm -r ${TEMPDIR}/usr/share/info
rm -r ${TEMPDIR}/usr/share/zoneinfo
rm -r ${TEMPDIR}/usr/share/perl5
rm -r ${TEMPDIR}/usr/share/pixmaps
rm -r ${TEMPDIR}/usr/share/common-licenses
rm -r ${TEMPDIR}/usr/lib/gconv
rm -r ${TEMPDIR}/var/lib/dpkg
rm -r ${TEMPDIR}/var/cache/debconf

# Remove useless file systems
mkdir ${TEMPDIR}/tmp/modules
mv ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/fs/ext3 ${TEMPDIR}/tmp/modules
mv ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/fs/msdos ${TEMPDIR}/tmp/modules
mv ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/fs/fat ${TEMPDIR}/tmp/modules
mv ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/fs/vfat ${TEMPDIR}/tmp/modules
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/fs/*
mv ${TEMPDIR}/tmp/modules/* ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/fs
rm -r ${TEMPDIR}/tmp/modules

# No sound needed
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/sound

# Only keep ipv4, ipv, unix, and packet networking modules
mkdir ${TEMPDIR}/tmp/modules
mv ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/net/ipv* ${TEMPDIR}/tmp/modules
mv ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/net/unix ${TEMPDIR}/tmp/modules
mv ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/net/packet ${TEMPDIR}/tmp/modules
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/net/*
mv ${TEMPDIR}/tmp/modules/* ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/net
rm -r ${TEMPDIR}/tmp/modules
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/net/ipv?/netfilter

# Remove useless device drivers
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/atm
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/i2c
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/isdn
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/media
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/mtd
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/video
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/w1

rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/net/appletalk
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/net/arcnet
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/net/bonding
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/net/hamradio
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/net/irda
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/net/tokenring
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/net/wan
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/net/wireless

rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/char/agp
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/char/drm
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/char/ftape
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/char/ipmi
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/char/mwave
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/char/rio
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/char/watchdog

rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/usb/gadget
rm -r ${TEMPDIR}/lib/modules/2.6.8-2-386/kernel/drivers/usb/media

dd if=/dev/zero of=${IMAGENAME} bs=1k count=34000
mke2fs -F ${IMAGENAME}
mount ${IMAGENAME} ${MOUNTDIR} -t ext2 -o loop
cp -ar ${TEMPDIR}/* ${MOUNTDIR}
umount ${MOUNTDIR}
gzip -f --best ${IMAGENAME}

echo
echo "Shrunk image to ${IMAGENAME}.gz"
echo "Temporary directory ${TEMPDIR} still exists"
